'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _queryDescriptor = require('../../objects/queryDescriptor');

var _queryDescriptor2 = _interopRequireDefault(_queryDescriptor);

var _breakpointMap = require('../../utils/breakpointMap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var nextBreakpointByIndex = function nextBreakpointByIndex(breakpointMap) {
  return (0, _ramda.pipe)((0, _breakpointMap.findNextBreakpointByIndex)(breakpointMap), (0, _ramda.nth)(1));
};

var createAtQueryDescriptor = function createAtQueryDescriptor(breakpointMap, rangeItem, rangeItemValue) {
  // We need to limit ourselves using a max of the next query if it exists.
  // Use our own index to check if there is a breakpoint after us
  var idx = (0, _breakpointMap.findBreakpointIndex)(breakpointMap, rangeItem.name);

  var nextBreakpointValue = void 0;
  if ((0, _breakpointMap.isNotLastBreakpoint)(breakpointMap, idx)) {
    nextBreakpointValue = nextBreakpointByIndex(breakpointMap)(idx);
  }

  // Otherwise we are the last breakpoint so we don't need a max
  return (0, _queryDescriptor2.default)({
    from: rangeItemValue,
    to: nextBreakpointValue
  });
};

exports.default = createAtQueryDescriptor;