'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _rangeItem = require('../../objects/rangeItem');

var _predicate = require('../../utils/predicate');

var _createAtQueryDecriptor = require('./createAtQueryDecriptor');

var _createAtQueryDecriptor2 = _interopRequireDefault(_createAtQueryDecriptor);

var _createGtQueryDescriptor = require('./createGtQueryDescriptor');

var _createGtQueryDescriptor2 = _interopRequireDefault(_createGtQueryDescriptor);

var _createLtQueryDescriptor = require('./createLtQueryDescriptor');

var _createLtQueryDescriptor2 = _interopRequireDefault(_createLtQueryDescriptor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createUnrangedQueryDescriptor = (0, _ramda.cond)([[(0, _ramda.either)(_rangeItem.hasNoModifier, _predicate.modifierIsGtModifier), function () {
  return _createGtQueryDescriptor2.default;
}], [_predicate.modifierIsLtModifier, function () {
  return _createLtQueryDescriptor2.default;
}], [_ramda.T, function () {
  return _createAtQueryDecriptor2.default;
}]]);

exports.default = createUnrangedQueryDescriptor;