'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _declarations = require('../utils/declarations');

var _processDeclarations = require('./declarations/processDeclarations');

var _processDeclarations2 = _interopRequireDefault(_processDeclarations);

var _renderBatch = require('./declarations/renderers/renderBatch');

var _renderBatch2 = _interopRequireDefault(_renderBatch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildApiFunc = function buildApiFunc(processors) {
  return (0, _ramda.pipe)((0, _processDeclarations2.default)(processors), _declarations.optimiseDeclarations, _declarations.batchDeclarations, _renderBatch2.default);
};

var buildMqFunc = function buildMqFunc(api) {
  api.mq = (0, _ramda.curry)(function (breakpoint, declarations) {
    return (0, _ramda.pipe)(_declarations.addBreakpointToDeclarations, api)(breakpoint, declarations);
  });
  return api;
};

var buildExtendFunc = function buildExtendFunc(baseConfig) {
  return function (api) {
    api.extend = (0, _ramda.pipe)((0, _ramda.mergeDeepRight)(baseConfig), _index2.default);
    return api;
  };
};

var createApi = function createApi(config) {
  return (0, _ramda.pipe)(buildApiFunc, buildMqFunc, buildExtendFunc(config));
};

exports.default = createApi;