'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ramda = require('ramda');

var _resolveBreakpoints = require('../../breakpoints/resolveBreakpoints');

var _resolveBreakpoints2 = _interopRequireDefault(_resolveBreakpoints);

var _objects = require('../../utils/objects');

var _createDeclarationProcessor = require('./createDeclarationProcessor');

var _createDeclarationProcessor2 = _interopRequireDefault(_createDeclarationProcessor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var create = function create(breakpoints, name, data, style) {
  return (0, _ramda.pipe)((0, _resolveBreakpoints2.default)(breakpoints), (0, _createDeclarationProcessor2.default)(name, data, style));
};

var createDeclarationProcessorReducer = function createDeclarationProcessorReducer(breakpoints, data) {
  return function (acc, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        name = _ref2[0],
        style = _ref2[1];

    return (0, _ramda.pipe)(create, (0, _ramda.assoc)(name, _ramda.__, acc))(breakpoints, name, data, style);
  };
};

var createDeclarationProcessors = function createDeclarationProcessors(_ref3) {
  var breakpoints = _ref3.breakpoints,
      data = _ref3.data,
      properties = _ref3.properties;
  return (0, _objects.reduceObjIndexed)(createDeclarationProcessorReducer(breakpoints, data), {}, properties);
};

exports.default = createDeclarationProcessors;