'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ramda = require('ramda');

var _ramdaAdjunct = require('ramda-adjunct');

var _errors = require('../../errors');

var _objects = require('../../utils/objects');

var processDeclaration = function processDeclaration(processors) {
  return function (acc, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        name = _ref2[0],
        args = _ref2[1];

    var processor = (0, _ramda.prop)(name, processors);
    (0, _ramda.when)(_ramda.isNil, function () {
      return (0, _errors.throwAPIError)((0, _errors.invalidPropertyError)(name));
    })(processor);
    return (0, _ramda.pipe)(_ramdaAdjunct.ensureArray, (0, _ramda.apply)(processor), (0, _ramdaAdjunct.appendFlipped)(acc))(args);
  };
};

var processDeclarations = function processDeclarations(processors) {
  return (0, _ramda.pipe)((0, _objects.reduceObjIndexed)(processDeclaration(processors), []), _ramda.unnest);
};

exports.default = processDeclarations;