'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _ramdaAdjunct = require('ramda-adjunct');

var _formatting = require('../../../utils/formatting');

var _renderQuery = require('./renderQuery');

var _renderQuery2 = _interopRequireDefault(_renderQuery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var writeToString = function writeToString(outputString) {
  return (0, _ramda.compose)(_formatting.joinWithDoubleNewlines, _ramdaAdjunct.compact, (0, _ramdaAdjunct.appendFlipped)([outputString]));
};

var renderStyle = function renderStyle(outputString, _ref) {
  var query = _ref.query,
      value = _ref.value;
  return (0, _ramda.pipe)(_formatting.joinWithNewline, (0, _ramda.unless)(function () {
    return (0, _ramda.isEmpty)(query);
  }, (0, _renderQuery2.default)(query)), writeToString(outputString))(value);
};

var renderBatch = (0, _ramda.reduce)(renderStyle, '');

exports.default = renderBatch;