'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _formatting = require('../../../utils/formatting');

var _renderDeclarations = require('./renderDeclarations');

var _renderDeclarations2 = _interopRequireDefault(_renderDeclarations);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderDualProps = function renderDualProps(propNames) {
  return function (_, value) {
    var firstProp = value[0];
    var lastProp = value[1] || firstProp;
    var directionValues = [firstProp, lastProp];

    return (0, _ramda.pipe)((0, _ramda.zip)(propNames), _renderDeclarations2.default, _formatting.joinWithNewline)(directionValues);
  };
};
exports.default = renderDualProps;