'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _createApi = require('./build/createApi');

var _createApi2 = _interopRequireDefault(_createApi);

var _createDeclarationProcessors = require('./build/declarations/createDeclarationProcessors');

var _createDeclarationProcessors2 = _interopRequireDefault(_createDeclarationProcessors);

var _ensureBreakpointProvider = require('./build/ensureBreakpointProvider');

var _ensureBreakpointProvider2 = _interopRequireDefault(_ensureBreakpointProvider);

var _expandData = require('./build/expansion/expandData');

var _expandData2 = _interopRequireDefault(_expandData);

var _expandProperties = require('./build/expansion/expandProperties');

var _expandProperties2 = _interopRequireDefault(_expandProperties);

var _mergeWithDefaultConfig = require('./build/mergeWithDefaultConfig');

var _mergeWithDefaultConfig2 = _interopRequireDefault(_mergeWithDefaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// -----------------------------------------------------------------------------
// Exports
// -----------------------------------------------------------------------------

var api = function api(config) {
  return (0, _ramda.pipe)(_mergeWithDefaultConfig2.default, _expandData2.default, _expandProperties2.default, _ensureBreakpointProvider2.default, _createDeclarationProcessors2.default, (0, _createApi2.default)(config))(config);
};

exports.default = api;