'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _errors = require('../errors');

var _resolveKeyToValue = require('../resolvers/resolveKeyToValue');

var _resolveKeyToValue2 = _interopRequireDefault(_resolveKeyToValue);

var _logic = require('../utils/logic');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var resolveKeyToObjectValue = function resolveKeyToObjectValue(dataPropName) {
  return function (propName, data, breakpointName) {
    return (0, _ramda.pipe)((0, _resolveKeyToValue2.default)(dataPropName), (0, _ramda.prop)(propName), (0, _logic.whenIsUndefined)(function () {
      return (0, _errors.throwDataError)((0, _errors.missingDataItemKeyError)(dataPropName, propName));
    }))(propName, data, breakpointName);
  };
};

exports.default = resolveKeyToObjectValue;