'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ramda = require('ramda');

var _ramdaAdjunct = require('ramda-adjunct');

var _resolveKeysToObjectValues = require('../../resolvers/resolveKeysToObjectValues');

var _resolveKeysToObjectValues2 = _interopRequireDefault(_resolveKeysToObjectValues);

var _resolveKeyToValue = require('../../resolvers/resolveKeyToValue');

var _resolveKeyToValue2 = _interopRequireDefault(_resolveKeyToValue);

var _baseline = require('../../utils/baseline');

var _converters = require('../../utils/converters');

var _formatting = require('../../utils/formatting');

var _logic = require('../../utils/logic');

var _transformers = require('../../utils/transformers');

var _transformer = require('../transformer');

var _transformer2 = _interopRequireDefault(_transformer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PROP = 'baseline';
var KEYS = ['lineHeight', 'minLeading', 'allowHalfLines'];

var rhythmUnitsToRemsTransformer = function rhythmUnitsToRemsTransformer(fontSizeToLengthTransformer) {
  return (0, _transformer2.default)(_ramda.T, function (value, data, breakpointName) {
    var _resolveKeysToObjectV = (0, _resolveKeysToObjectValues2.default)(PROP, KEYS)(data, breakpointName),
        _resolveKeysToObjectV2 = _slicedToArray(_resolveKeysToObjectV, 3),
        lineHeight = _resolveKeysToObjectV2[0],
        minLeading = _resolveKeysToObjectV2[1],
        allowHalfLines = _resolveKeysToObjectV2[2];

    var baseFontSize = (0, _resolveKeyToValue2.default)('baseFontSize')(value, data, breakpointName);

    var _unless = (0, _ramda.unless)(_ramdaAdjunct.isArray, _formatting.splitOnUnnestedWhitespace)(value),
        _unless2 = _slicedToArray(_unless, 2),
        fontSize = _unless2[0],
        lines = _unless2[1];

    var transformedFontSize = (0, _transformers.transformValue)(fontSizeToLengthTransformer, data, breakpointName, fontSize);
    var fontSizeUnitlessPx = (0, _converters.unitedDimensionToUnitlessPixelValue)(transformedFontSize, baseFontSize);

    var transformedLines = (0, _ramda.pipe)((0, _logic.whenIsUndefined)(function () {
      return (0, _baseline.linesForFontsize)(minLeading, allowHalfLines, lineHeight, fontSizeUnitlessPx);
    }), (0, _ramda.multiply)(lineHeight), (0, _transformers.transformValue)(fontSizeToLengthTransformer, data, breakpointName))(lines);

    return [transformedFontSize, transformedLines];
  });
};

exports.default = rhythmUnitsToRemsTransformer;