'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _resolveKeyToObjectValue = require('../resolvers/resolveKeyToObjectValue');

var _resolveKeyToObjectValue2 = _interopRequireDefault(_resolveKeyToObjectValue);

var _data = require('../utils/data');

var _parse = require('../utils/parse');

var _predicate = require('../utils/predicate');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Lookup the value of an object, for example `color.primary`
var dataLookupTransformer = function dataLookupTransformer(nodeName) {
  return function (value, data, breakpointName) {
    var nameAndAliases = (0, _data.nameAndAliasesForNodeName)(data.aliases, nodeName);

    return (0, _ramda.when)((0, _predicate.tokenMatches)(nameAndAliases), function () {
      var name = (0, _parse.tokenName)(value);
      return (0, _resolveKeyToObjectValue2.default)(nodeName)(name, data, breakpointName);
    })(value);
  };
};

exports.default = dataLookupTransformer;