'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _predicate = require('../utils/predicate');

var _transformers = require('../utils/transformers');

var _transformPartsWith = require('./composite/transformPartsWith');

var _transformPartsWith2 = _interopRequireDefault(_transformPartsWith);

var _transformer = require('./transformer');

var _transformer2 = _interopRequireDefault(_transformer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var impl = function impl(transformers) {
  return function (value, data, breakpointName) {
    return (0, _transformers.transformFunctionElements)((0, _transformers.transformValue)((0, _transformPartsWith2.default)(transformers), data, breakpointName))(value);
  };
};

var gradientTransformer = function gradientTransformer(transformers) {
  return function (value, data, breakpointName) {
    return (0, _transformer2.default)(_predicate.isGradient, impl(transformers))(value, data, breakpointName);
  };
};

exports.default = gradientTransformer;