'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _units = require('../const/units');

var _resolveKeyToValue = require('../resolvers/resolveKeyToValue');

var _resolveKeyToValue2 = _interopRequireDefault(_resolveKeyToValue);

var _converters = require('../utils/converters');

var _predicate = require('../utils/predicate');

var _transformer = require('./transformer');

var _transformer2 = _interopRequireDefault(_transformer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rhythmUnitsToRemsTransformer = (0, _transformer2.default)(_predicate.isRhythmUnit, function (value, data, breakpointName) {
  var rhythm = (0, _resolveKeyToValue2.default)('rhythm')(value, data, breakpointName);
  return (0, _converters.mulitplyUnitlessNumbersToDistance)(rhythm, data.baseFontSize, _units.LENGTH_UNITS.REM)(value);
});

exports.default = rhythmUnitsToRemsTransformer;