'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.linesForFontsize = undefined;

var _ramdaAdjunct = require('ramda-adjunct');

var _numbers = require('./numbers');

var wholeLinesForFontSize = function wholeLinesForFontSize(minLeading, fontSize, baselineHeight) {
  var lines = Math.ceil(fontSize / baselineHeight);
  return lines * baselineHeight - fontSize >= minLeading ? lines : lines + 1;
};

// eslint-disable-next-line import/prefer-default-export
var linesForFontsize = exports.linesForFontsize = function linesForFontsize(minLeading, allowHalfLines, baselineHeight, fontSize) {
  return (0, _ramdaAdjunct.isTrue)(allowHalfLines) ? (0, _numbers.divideBy2)(wholeLinesForFontSize(minLeading, fontSize, (0, _numbers.divideBy2)(baselineHeight))) : wholeLinesForFontSize(minLeading, fontSize, baselineHeight);
};