'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.calculateQueryDescriptorForRange = exports.calculateQueryDescriptor = undefined;

var _ramda = require('ramda');

var _createRangedQueryDescriptor = require('../breakpoints/descriptors/createRangedQueryDescriptor');

var _createRangedQueryDescriptor2 = _interopRequireDefault(_createRangedQueryDescriptor);

var _createUnrangedQueryDescrptor = require('../breakpoints/descriptors/createUnrangedQueryDescrptor');

var _createUnrangedQueryDescrptor2 = _interopRequireDefault(_createUnrangedQueryDescrptor);

var _breakpointMapping = require('../objects/breakpointMapping');

var _queryDescriptor = require('../objects/queryDescriptor');

var _queryDescriptor2 = _interopRequireDefault(_queryDescriptor);

var _list = require('../utils/list');

var _range = require('../utils/range');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// -----------------------------------------------------------------------------
// Query Header
// -----------------------------------------------------------------------------

// Use an array of mappings to decide which header to render
var calculateQueryDescriptor = exports.calculateQueryDescriptor = function calculateQueryDescriptor(idx, mappedValues) {
  var queryValue = (0, _breakpointMapping.propQuery)(mappedValues[idx]);
  var nextQueryValue = void 0;
  if (idx < mappedValues.length - 1) {
    nextQueryValue = (0, _breakpointMapping.propQuery)(mappedValues[idx + 1]);
  }
  return (0, _queryDescriptor2.default)({ from: queryValue, to: nextQueryValue });
};

var calculateQueryDescriptorForRange = exports.calculateQueryDescriptorForRange = function calculateQueryDescriptorForRange(breakpointMap) {
  return function (range) {
    var firstRangeItem = (0, _ramda.head)(range);
    var firstItemValue = (0, _range.applyOffsetToBreakpointValue)(firstRangeItem);
    var renderQuery = (0, _list.lengthEq1)(range) ? (0, _createUnrangedQueryDescrptor2.default)(firstRangeItem) : _createRangedQueryDescriptor2.default;
    return renderQuery(breakpointMap, firstRangeItem, firstItemValue, range);
  };
};